﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Security.Cryptography.Pkcs;
using System.Security.Cryptography.X509Certificates;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;

namespace PDFSample
{
    public partial class _Default : Page
    {
        protected void OnButtonClicked(object sender, EventArgs e)
        {
            string docPath = Server.MapPath("/App_Data/Barcode.pdf");
            PdfLoadedDocument document = new PdfLoadedDocument(docPath);

            //Create a revision 2 signature with loaded digital ID.
            PdfSignature signature = new PdfSignature(document, document.Pages[0], null, "DigitalSignature");
            signature.ComputeHash += Signature_ComputeHash;

            //Open the document in browser after saving it
            document.Save("Output.pdf", HttpContext.Current.Response, HttpReadType.Save);

            document.Close(true);
        }

        private void Signature_ComputeHash(object sender, PdfSignatureEventArgs ars)
        {
            //Get the document bytes.
            byte[] documentBytes = ars.Data;

            SignedCms signedCms = new SignedCms(new ContentInfo(documentBytes), detached: true);
            X509Store store = new X509Store("MY", StoreLocation.CurrentUser);
            store.Open(OpenFlags.ReadOnly | OpenFlags.OpenExistingOnly);
            X509Certificate2Collection collection = (X509Certificate2Collection)store.Certificates;
            //load your smart card certificate

            X509Certificate2 certificate = new X509Certificate2(collection[3]);
            CmsSigner cmsSigner = new CmsSigner(certificate);
            //Set the digest algorithm SHA256.
            cmsSigner.DigestAlgorithm = new Oid("2.16.840.1.101.3.4.2.1");
            signedCms.ComputeSignature(cmsSigner);
            //Embed the encoded digital signature to the PDF document.
            ars.SignedData = signedCms.Encode();
        }
    }
}